var Check = function()
{
	var check = {};
	var debug = 0;
	
	var currentLaneNo = 1;
	var expectedCycles = 0;
	var expectedTiles = 0;
	var readString
	var seqRun;
	
	check.initPage = function()
	{
		var frm = document.forms['reggie'];
		Buttons.addClickHandler('close', App.closeWindow);
		
		var seqRunId = Data.get('page-data', 'seqrun-id');
		var url = '../SequencingRun.servlet?ID='+App.getSessionId();
		url += '&cmd=GetSeqRunInfoForDataCheck';
		url += '&seqrun='+Data.get('page-data', 'seqrun-id');
		Wizard.asyncJsonRequest(url, check.seqRunLoaded);
		
		// Load open grid clusters
		var url = '../OpenGrid.servlet?ID='+App.getSessionId() + '&cmd=GetHostInfo';
		Doc.addClass('clusters', 'list-loading');
		frm.clusters[0] = new Option('loading...');
		Wizard.asyncJsonRequest(url, check.clustersLoaded);
	}
	
	
	check.seqRunLoaded = function(response)
	{
		var frm = document.forms['reggie'];
		seqRun = response.seqRun;
		
		Doc.element('sequencingrun').innerHTML = Strings.encodeTags(seqRun.name);
		Doc.element('flowCellId').innerHTML = Strings.encodeTags(seqRun.flowCell.FlowCellID);
		Doc.element('dataFilesFolder').innerHTML = Strings.encodeTags(seqRun.DataFilesFolder);
		Doc.element('sequencingCycles').innerHTML = Strings.encodeTags(seqRun.SequencingCycles);
		Doc.element('flowCellType').innerHTML = Strings.encodeTags(seqRun.flowCell.FlowCellType);
		if (!frm.readString.value)
		{
			frm.readString.value = seqRun.ReadString;
		}
		
		var omitLanes = Data.json('page-data', 'omit-lanes');
		
		var html = '';
		var numLanes = seqRun.flowCell.numLanes;
		for (var laneNo = 1; laneNo <= numLanes; laneNo++)
		{
			var checked = omitLanes.indexOf(laneNo) == -1 ? 'checked' : '';
			html += '<tr><th class="subprompt">Lane ' + laneNo + '<input type="checkbox" name="lane.'+laneNo+'" '+checked+'></td>';
			html += '<td id="lane.'+laneNo+'.status" class="status"></td>';
			html += '<td><span id="lane.'+laneNo+'.message" class="message" data-display="block"></span></td>';
			html += '</tr>';
		}
		
		Doc.element('lanes-section').innerHTML = html;
	}

	check.clustersLoaded = function(response)
	{
		Doc.removeClass('clusters', 'list-loading');
		var frm = document.forms['reggie'];
		var clusters = response.hosts;
		frm.clusters.length = 0;
		for (var i = 0; i < clusters.length; i++)
		{
			var cl = clusters[i];
			cl.nodes = [];
			for (var n = 0; n < cl.config.nodes.length; n++)
			{
				var node = cl.config.nodes[n];
				var option = new Option(node.name+'@'+cl.connection.name, node.name+'@'+cl.id);
				option.cluster = cl;
				option.node = node;
				frm.clusters[frm.clusters.length] = option;
			}
			var option = new Option(cl.connection.name, cl.id);
			option.cluster = cl;
			frm.clusters[frm.clusters.length] = option;
		}
		if (frm.clusters.length == 0)
		{
			Wizard.setFatalError('No available Open Grid clusters');
		}
		else
		{
			Doc.show('check');
			Buttons.addClickHandler('check', check.performCheck);
		}
	}

	
	check.performCheck = function()
	{
		var frm = document.forms['reggie'];

		readString = frm.readString.value;
		if (!readString.match(/^(\d+[TBS])+$/))
		{
			Forms.showNotification(frm.readString, 'Not a valid read string', null, 'pointer-below');
			return;
		}
		
		// Reset data
		Doc.addClass('check', 'disabled');
		currentLaneNo = 1;
		expectedTiles = seqRun.flowCell.FlowCellType == 'NextSeq' ? 216 : 96;
		expectedCycles = 0;
		var reads = readString.match(/\d+(?=T|B)/g);
		for (var i = 0; i < reads.length; i++)
		{
			expectedCycles += parseInt(reads[i]);
		}
		
		check.runNextCheck();
	}

	
	check.runNextCheck = function()
	{
		var frm = document.forms['reggie'];

		if (!frm['lane.'+currentLaneNo].checked)
		{
			setTimeout(check.checkPerformed, 100);
			return;
		}
		
		var selected = frm.clusters[frm.clusters.selectedIndex];
		var cluster = selected.cluster;
		var node = selected.node;
		
		var url = '../SequencingRun.servlet?ID='+App.getSessionId();
		url += '&cmd=CheckIlluminaDataFiles';
		url += '&seqrun='+Data.get('page-data', 'seqrun-id');
		url += '&readString='+encodeURIComponent(readString);
		url += '&cluster='+encodeURIComponent(cluster.id);
		url += '&program='+Forms.getCheckedRadio(frm, 'program').value;
		if (node)
		{
			url += '&node='+encodeURIComponent(node.name);
		}
		url += '&lane='+currentLaneNo;
		
		Wizard.setInputStatus('lane.'+currentLaneNo, 'checking', 'Checking...');
		Wizard.asyncJsonRequest(url, check.checkPerformed);
	}
	
	check.checkPerformed = function(response)
	{
		var frm = document.forms['reggie'];
		if (!response)
		{
			Wizard.setInputStatus('lane.'+currentLaneNo, '', 'Skipped');
		}
		else
		{
			var program = Forms.getCheckedRadio(frm, 'program').value;
			var exitStatus = response.exitStatus;
			if (program == 'picard')
			{
				check.setPicardStatus(currentLaneNo, exitStatus, response.stdout, response.stderr);
			}
			else
			{
				check.setGenseqStatus(currentLaneNo, exitStatus, response.stdout, response.stderr);
			}
		}

		if (currentLaneNo < seqRun.flowCell.numLanes) 
		{
			currentLaneNo++;
			check.runNextCheck();
		}
		else
		{
			Doc.removeClass('check', 'disabled');
		}
	}
	
	check.setPicardStatus = function(laneNo, exitStatus, stdout, stderr)
	{
		var status = exitStatus == 0 ? 'valid' : 'invalid';
		var msg = '';

		if (exitStatus == 0)
		{
			var cycles;
			var tiles;
			var lines = stdout.split(/\n/);
			for (var lineNo = 0; lineNo < lines.length; lineNo++)
			{
				var line = lines[lineNo];
				var c = line.indexOf('Expected cycles');
				if (c > 0)
				{
					cycles = line.substring(c).match(/\d+/g);
				}
				var t = line.indexOf('Expected tiles');
				if (t > 0)
				{
					tiles = line.substring(t).match(/\d+/g);
				}
			}
			
			msg = (cycles == null ? 'unknown' : cycles.length) + ' cycles';
			if (cycles == null || cycles.length != expectedCycles)
			{
				msg += ' (expected ' + expectedCycles + ')';
				status = 'warning';
			}
			
			msg += '; ' + (tiles == null ? 'unknown' : tiles.length) + ' tiles';
			if (tiles == null || tiles.length != expectedTiles)
			{
				msg += ' (expected ' + expectedTiles + ')';
				status = 'warning';
			}
		}
		else
		{
			msg = stderr || stdout;
		}
		
		Wizard.setInputStatus('lane.'+laneNo, status, msg);
	}
	
	check.setGenseqStatus = function(laneNo, exitStatus, stdout, stderr)
	{
		var status = exitStatus == 0 ? 'valid' : 'invalid';
		var msg = '';
		var lines = stdout.split(/\n/);
		for (var lineNo = 1; lineNo < lines.length; lineNo++)
		{
			var line = lines[lineNo];
			msg += line + '\n';
		}
		
		Wizard.setInputStatus('lane.'+laneNo, status, msg);
	}

	
	return check;
}();

Doc.onLoad(Check.initPage);
